//+------------------------------------------------------------------+
//|                                                        PR_LU.mq4 |
//|                                                           Candid |
//|                                         http://candid.110mb.com/ |
//+------------------------------------------------------------------+
string IndName = "PR_LU";

#property copyright "Candid"
#property link      "http://candid.110mb.com/"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Blue
#property indicator_width1 2

extern int n = 53;
extern int Frame = 720;

int pos;
int i,j;
int ij;
int ish;

double A[];
double B[];
double B1[];
double LU[];
int indx[];
double D;
double ASum[];
int N2;
int N;
int NN;
double X;
double Y;
double pX;

double TINY = 0.00001;
double vv[];           // vv stores the implicit scaling of each row.

double Buf1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
  TINY *= TINY;
  TINY *= TINY; // 1.0e-20, a small number.
  N2 = n+n;
  N = n+1;
  NN = N*N;
  ArrayResize(A,NN);
  ArrayResize(B,N);
  ArrayResize(B1,N);
  ArrayResize(LU,NN);
  ArrayResize(indx,N);
  ArrayResize(ASum,N2);
  ArrayResize(vv,N);

  SetIndexBuffer(0,Buf1);
  SetIndexStyle(0,DRAW_LINE,EMPTY,2);
  SetIndexEmptyValue(0,0.0);
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
//  
  ArrayInitialize(B,0.0);
  ArrayInitialize(ASum,0.0);
//  
  for (pos=1;pos<=Frame;pos++) {
    X = pos;
    Y = Close[pos];
    pX = X;
    ASum[0] += pX;
    B[0] += Y;
    for (i=1;i<N2;i++) {
      if (i<N) B[i] += Y*pX;
      pX *= X;
      ASum[i] += pX;
    }
  }  
//  
  ish = -N;
  for (i=0;i<N;i++) {
    ish += N;
    for (j=0;j<N;j++) {
      ij = i+j-1;
      if (ij < 0 ) A[0] = Frame;
      else A[ish+j] = ASum[ij];
    }
  }
//    
  if (ludcmp(A,N,LU,indx,D)) lubksb(LU,N,indx,B);
//  
  for (pos=1;pos<=Frame;pos++) {
    X = pos;
    pX = X;
    Y = B[0]+pX*B[1];
    for (i=2;i<N;i++) {
      pX *= X;
      Y += pX*B[i];
    }
    Buf1[pos] = Y;
  }  
  Buf1[pos] = 0.0;
  return(0);
}
//+------------------------------------------------------------------+
void lubksb(double LU[], int n, int indx[], double& B[]) {
// Solves the set of n linear equations A*X = B. Here LU[0..n-1][1..n-1] is input, 
// not as the matrix A but rather as its LU decomposition, determined by the
// routine ludcmp. indx[0..n-1] is input as the permutation vector returned by
// ludcmp. B[0..n-1] is input as the right-hand side vector B, and returns with
// the solution vector X. LU, n, and indx are not modified by this routine
// and can be left in place for successive calls with different right-hand
// sides B. This routine takes into account the possibility that B will begin
// with many zero elements, so it is efficient for use in matrix inversion.
  int i,ii=0,ip,j;
  int ish;
  double sum;
  ish = -n;
  for (i=0;i<n;i++) { // When ii is set to a positive value, it will become
    ish += n;         // the index of the first nonvanishing element of B. We now 
    ip=indx[i];       // do the forward substitution. The only
	 sum=B[ip];        //  new wrinkle is to unscramble the permutation as we go.
	 B[ip]=B[i];     
    if (ii > 0) for (j=ii-1;j<i;j++) sum -= LU[ish+j]*B[j];
    else if (sum > 0.0) ii=i+1; // A nonzero element was encountered, so from now on we
    B[i]=sum;           // will have to do the sums in the loop above.
  }
  ish = n*n;
  for (i=n-1;i>=0;i--) {  // Now we do the backsubstitution.
    ish -= n;
    sum=B[i];
    for (j=i+1;j<n;j++) sum -= LU[ish+j]*B[j];
    B[i]=sum/LU[ish+i];   // Store a component of the solution vector X.
  }                      // All done!
}
//+------------------------------------------------------------------+
bool ludcmp(double A[], int n, double& LU[], int& indx[], double& d) {
// Given a matrix A[0..n-1][0..n-1], this routine replaces it by the LU decomposition of a rowwise
// permutation of itself. A and n are input. Aand n are not modified by this routine. LU is output;
// indx[0..n-1] is an output vector that records the row permutation effected by the partial
// pivoting; d is output as +-1 depending on whether the number of row interchanges was even
// or odd, respectively. This routine is used in combination with lubksb to solve linear equations
// or invert a matrix.
  int i,imax,j,k;
  int ish,jsh,ksh,imaxsh;
  int i1,i2;
  double big,dum,sum,temp;
  int n1 = n-1;
  d=1.0;              // No row interchanges yet.
  ish = -n;
  for (i=0;i<n;i++) { // Loop over rows to get the implicit scaling information.
    ish += n;
    big=0.0;
    for (j=0;j<n;j++) {
      i2 = ish+j;
      temp = A[i2];
      LU[i2] = temp;
      if (temp < 0.0) temp = -temp;
      if (temp > big) big=temp;
    }
    if (big == 0.0) {
// No nonzero largest element.
      Print("function ludcmp: Singular matrix");
      return(false);
    } else {
      vv[i]=1.0/big;     // Save the scaling.
    }
  }
  jsh = -n;
  for (j=0;j<n;j++) {   // This is the loop over columns of Crout's method.
    jsh += n;
    ish = -n;
    for (i=0;i<j;i++) {  //  This is equation (2.3.12) except for i = j.
      ish += n;
      i2 = ish+j;
      sum=LU[i2];
      ksh = -n;
      for (k=0;k<i;k++) {
        ksh += n;
        sum -= LU[ish+k]*LU[ksh+j];
      }
      LU[i2]=sum;
    }
    big=0.0;             // Initialize for the search for largest pivot element.
    for (i=j;i<n;i++) {  // This is i = j of equation (2.3.12) and i = j+1 : ::N
      ish += n;
      i2 = ish+j;
      sum=LU[i2];          //  of equation (2.3.13). 
      ksh = -n;
      for (k=0;k<j;k++) {
        ksh += n;
        sum -= LU[ish+k]*LU[ksh+j];
      }
      LU[i2]=sum;
      if (sum < 0) sum = -sum;
      dum=vv[i]*sum;
      if (dum >= big) {
// Is the figure of merit for the pivot better than the best so far?
        big=dum;
        imax=i;
      }
    }
    if (j != imax) {     // Do we need to interchange rows?
      imaxsh = imax*n;
      for (k=0;k<n;k++) { // Yes, do so...
        i1 = imaxsh+k;
        i2 = jsh+k;
        dum=LU[i1];
        LU[i1]=LU[i2];
        LU[i2]=dum;
      }
      d = -d;          // ...and change the parity of d.
      vv[imax]=vv[j];      // Also interchange the scale factor.
    }
    indx[j]=imax;
    i2 = jsh+j;
    if (LU[i2] == 0.0) LU[i2]=TINY;
// If the pivot element is zero the matrix is singular (at least to the precision of the
// algorithm). For some applications on singular matrices, it is desirable to substitute
// TINY for zero.
    if (j != n1) {        // Now, finally, divide by the pivot element.
      dum=1.0/(LU[i2]);
      ish = i*j;
      for (i=j+1;i<n;i++) {
        ish += n;
        LU[ish+j] *= dum;
      }
    }
  }                    // Go back for the next column in the reduction.
  return(true);
}

